Subject: Re: [PATCH v2 1/5] arm64/sysreg: Add HDBSS related register information

From: Leonardo Bras <[email-masked]>
Date: Thu, 22 Jan 2026 15:12:28 +0000

On Sat, Nov 22, 2025 at 12:40:27PM +0000, Marc Zyngier wrote:
> On Fri, 21 Nov 2025 09:23:38 +0000,
> Tian Zheng <[email-masked]> wrote:
> > 
> > From: eillon <[email-masked]>
> > 
> > The ARM architecture added the HDBSS feature and descriptions of
> > related registers (HDBSSBR/HDBSSPROD) in the DDI0601(ID121123) version,
> > add them to Linux.
> > 
> > Signed-off-by: eillon <[email-masked]>
> > Signed-off-by: Tian Zheng <[email-masked]>
> > ---
> >  arch/arm64/include/asm/esr.h     |  2 ++
> >  arch/arm64/include/asm/kvm_arm.h |  1 +
> >  arch/arm64/tools/sysreg          | 28 ++++++++++++++++++++++++++++
> >  3 files changed, 31 insertions(+)
> > 
> > diff --git a/arch/arm64/include/asm/esr.h b/arch/arm64/include/asm/esr.h
> > index e1deed824464..a6f3cf0b9b86 100644
> > --- a/arch/arm64/include/asm/esr.h
> > +++ b/arch/arm64/include/asm/esr.h
> > @@ -159,6 +159,8 @@
> >  #define ESR_ELx_CM 		(UL(1) << ESR_ELx_CM_SHIFT)
> > 
> >  /* ISS2 field definitions for Data Aborts */
> > +#define ESR_ELx_HDBSSF_SHIFT	(11)
> > +#define ESR_ELx_HDBSSF		(UL(1) << ESR_ELx_HDBSSF_SHIFT)
> >  #define ESR_ELx_TnD_SHIFT	(10)
> >  #define ESR_ELx_TnD 		(UL(1) << ESR_ELx_TnD_SHIFT)
> >  #define ESR_ELx_TagAccess_SHIFT	(9)
> > diff --git a/arch/arm64/include/asm/kvm_arm.h b/arch/arm64/include/asm/kvm_arm.h
> > index 1da290aeedce..b71122680a03 100644
> > --- a/arch/arm64/include/asm/kvm_arm.h
> > +++ b/arch/arm64/include/asm/kvm_arm.h
> > @@ -124,6 +124,7 @@
> >  			 TCR_EL2_ORGN0_MASK | TCR_EL2_IRGN0_MASK)
> > 
> >  /* VTCR_EL2 Registers bits */
> > +#define VTCR_EL2_HDBSS		(1UL << 45)
> 
> I think it is time to convert VTCR_EL2 to the sysreg infrastructure
> instead of adding extra bits here.

Hi Marc, Tian,

Marc, IIUC the above was implemented by 
https://lore.kernel.org/all/[email-masked]

Which was recently applied to next, and it its way to mainstream.

Tian, I think it's worth rebasing this patchset on top of the above.

BTW, I am working on using the feature enabled by this patchset on a new 
optimization, so please include me on any new release.

Thanks!
Leo